/* ====================================
		o[W\_CAO
==================================== */
#include "stdafx.h"
#include "gdippManager.h"
#pragma comment(lib, "version.lib")


/* ====================================
		錾
==================================== */
static bool OnInitDialog(HWND hwnd);
static void GetWinVersion(LPTSTR verinfo);
static void GetVersionString(LPTSTR verinfo, LPTSTR trgPath, const int infoSz, LPTSTR vbuff);
static void GetVersionValue(LPTSTR tmpValue, LPCTSTR category,
														 const int infoSz, const int localeId,
														 LPTSTR vbuff, LPTSTR buff);


/* ====================================
		ϐ
==================================== */
static const TCHAR NO_VALUE[] = TEXT("̍ڂ̒l܂ł");
static const TCHAR NO_RES[]   = TEXT("o[Wǂݍ߂܂ł");



/* ====================================
		`
==================================== */
// msgproc
BOOL CALLBACK DialogProc(HWND hwnd, UINT msg, WPARAM /*wParam*/, LPARAM /*lParam*/)
{
	switch (msg) {
	case WM_INITDIALOG:
		if (!OnInitDialog(hwnd))
			EndDialog(hwnd, IDABORT);
		return TRUE;

	case WM_CLOSE:
		EndDialog(hwnd, IDOK);
		return TRUE;
	}
	return FALSE;
}

// o[W擾\(Ȃ
static bool OnInitDialog(HWND hwnd)
{
	DWORD  exeInfoSz, dllInfoSz, tmp;
	LPTSTR exeInfo, dllInfo, outInfo, tmpBuff;
	TCHAR  exePath[MAX_PATH],
				 osInfo[128];

	exeInfo = dllInfo = outInfo = tmpBuff = NULL;
	GetModuleFileName(NULL, exePath, sizeof(exePath));

	// \[X̃TCY擾ăobt@m
	exeInfoSz = GetFileVersionInfoSize(exePath, &tmp);
	if (exeInfoSz) {
		exeInfo = (LPTSTR)HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, exeInfoSz*sizeof(TCHAR));
		tmpBuff = (LPTSTR)HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, exeInfoSz*sizeof(TCHAR));
		if (exeInfo && tmpBuff)
			GetVersionString(exeInfo, exePath, exeInfoSz, tmpBuff);
		HeapFree(GetProcessHeap(), 0, tmpBuff);

	// \[XȂȂ128oCg̕
	} else {
		exeInfoSz = 128;
		exeInfo   = (LPTSTR)HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, exeInfoSz*sizeof(TCHAR));
		if (exeInfo)
			lstrcat(exeInfo, NO_RES);
	}

	// ƑS
	dllInfoSz = GetFileVersionInfoSize(g_dllPath, &tmp);
	if (dllInfoSz) {
		dllInfo = (LPTSTR)HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, dllInfoSz*sizeof(TCHAR));
		tmpBuff = (LPTSTR)HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, dllInfoSz*sizeof(TCHAR));
		if (dllInfo && tmpBuff)
			GetVersionString(dllInfo, g_dllPath, dllInfoSz, tmpBuff);
		HeapFree(GetProcessHeap(), 0, tmpBuff);
	} else {
		dllInfoSz = 128;
		dllInfo   = (LPTSTR)HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, dllInfoSz*sizeof(TCHAR));
		if (dllInfo)
			lstrcat(dllInfo, NO_RES);
	}

	// o
	outInfo = (LPTSTR)HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, (exeInfoSz+dllInfoSz)*sizeof(TCHAR));
	if (outInfo == NULL || dllInfo == NULL || exeInfo == NULL)
		return false;

	GetWinVersion(osInfo);

	wsprintf(outInfo, TEXT("yOSz\r\n%s\r\nyEXEz\r\n%s\r\nyDLLz\r\n%s"), osInfo, exeInfo, dllInfo);
	SetDlgItemText(hwnd, IDC_EDIT1002, outInfo);

	HeapFree(GetProcessHeap(), 0, exeInfo);
	HeapFree(GetProcessHeap(), 0, dllInfo);
	HeapFree(GetProcessHeap(), 0, outInfo);
	return true;
}

static void GetWinVersion(LPTSTR verinfo)
{
	OSVERSIONINFO osInfo;
	osInfo.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx(&osInfo);

	wsprintf(verinfo, TEXT("%d.%d.%d.%s\r\n"), osInfo.dwMajorVersion, osInfo.dwMinorVersion,
		osInfo.dwBuildNumber, osInfo.szCSDVersion);
}

// verinfo  trgPath ̃\[Xi[
static void GetVersionString(LPTSTR verinfo, LPTSTR trgPath, const int infoSz, LPTSTR vbuff)
{
	int    localeId;
	TCHAR  tmpValue[256];
	LPTSTR buff = NULL;

	if (GetFileVersionInfo(trgPath, 0, infoSz, vbuff)) {
		if (VerQueryValue(vbuff, TEXT("\\VarFileInfo\\Translation"), (void**)&buff, (PUINT)&infoSz)) {
			CopyMemory(&localeId, buff, sizeof(int));

			// ̃ZbgǉOK
			GetVersionValue(tmpValue, TEXT("FileVersion"), infoSz, localeId, vbuff, buff);
			lstrcat(verinfo, tmpValue);
			GetVersionValue(tmpValue, TEXT("Comments"), infoSz, localeId, vbuff, buff);
			lstrcat(verinfo, tmpValue);
		}
	} else {
		lstrcat(verinfo, NO_RES);
	}
}

// tmpValuecategory̒li[
// o͏́@category: l\r\n@ɂȂ
static void GetVersionValue(LPTSTR tmpValue, LPCTSTR category,
														 const int infoSz, const int localeId,
														 LPTSTR vbuff, LPTSTR buff)
{
	TCHAR fmtStr[1024];
	wsprintf(fmtStr, TEXT("\\StringFileInfo\\%04X%04X\\%s"), LOWORD(localeId), HIWORD(localeId), category);
	if (VerQueryValue(vbuff, fmtStr, (void**)&buff, (PUINT)&infoSz) == 0)
		lstrcpy(buff, NO_VALUE);
	wsprintf(tmpValue, TEXT("%s: %s\r\n"), category, buff);
}
	/* ----------------------------------
		CompanyName      Ж
		FileDescription	 
		FileVersion	     t@Co[W
		InternalName	   
		LegalCopyright	 쌠
		OriginalFileName t@C
		ProductName      i
		ProductVersion   io[W
		Comments         Rg
		LegalTrademarks  W
		PrivateBuild	   vCx[grh
		SpecialBuild     XyVrh
	---------------------------------- */

// EOF
